;Draw 3d W Shape
(apply '(lambda (/ a b c flgthk halfflg halfweb halfdep webdpth a90 a270 ip1 ip2
                   cp1 cp2 p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12
                   p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24)
   (setvar "cmdecho" 0)
   (princ (strcat "\nDrawing 3d View of [" (nth 0 SHP_DATA) "]"))
   (setq ip1
      (cond
         ((= STL_INPUT_MODE "stl_ia") (setq b 1) (getpoint "\n[PICK] Center Top of Flange point: "))
         ((= STL_INPUT_MODE "stl_ib") (setq b 2) (getpoint "\n[PICK] Center Bottom of Flange point: "))
         ((= STL_INPUT_MODE "stl_ic") (setq b 3) (getpoint "\n[PICK] Center of Web at X Axis: "))
      )
   )
   (if (= STL_DRAW_MODE "stl_db") ;Draw Mode
      (setq flgthk 0.5 webthk 0.5)
      (setq flgthk (nth 4 shp_data) webthk (nth 2 shp_data))
   )
   (while (setq ip2 (getpoint ip1 "\n[PICK] End point: "))
      (setq halfflg (/ (nth 3 shp_data) 2.0)
            halfweb (/ webthk 2.0)
            halfdep (/ (nth 1 shp_data) 2.0)
            webdpth (- (nth 1 shp_data) (* 2.0 flgthk))
      )
      (setq a90  (+ (angle ip1 ip2) (* pi 0.5))
            a270 (+ (angle ip1 ip2) (* pi 1.5))
      )
      (cond
         ((= b 1) (setq cp1 ip1 cp2 ip2))
         ((= b 2)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 1 SHP_DATA)))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 1 SHP_DATA)))
            )
         )
         ((= b 3)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) halfdep))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) halfdep))
            )
         )
      )
      (setq p1  (polar cp1 a90 halfflg)
            p13 (polar cp2 a90 halfflg)
            p2  (polar cp1 a270 halfflg)
            p14 (polar cp2 a270 halfflg)
            p6  (list (car p1)  (cadr p1)  (- (caddr p1)  flgthk))
            p18 (list (car p13) (cadr p13) (- (caddr p13) flgthk))
            p3  (list (car p2)  (cadr p2)  (- (caddr p2)  flgthk))
            p15 (list (car p14) (cadr p14) (- (caddr p14) flgthk))
            p5  (polar p6  a270 (- halfflg halfweb))
            p17 (polar p18 a270 (- halfflg halfweb))
            p4  (polar p3  a90 (- halfflg halfweb))
            p16 (polar p15 a90 (- halfflg halfweb))
            p10 (list (car p4)  (cadr p4)  (- (caddr p4)  webdpth))
            p11 (list (car p5)  (cadr p5)  (- (caddr p5)  webdpth))
            p22 (list (car p16) (cadr p16) (- (caddr p16) webdpth))
            p23 (list (car p17) (cadr p17) (- (caddr p17) webdpth))
            p12 (list (car p1)  (cadr p1)  (- (caddr p1)  (- (nth 1 shp_data) flgthk)))
            p9  (list (car p2)  (cadr p2)  (- (caddr p2)  (- (nth 1 shp_data) flgthk)))
            p21 (list (car p14) (cadr p14) (- (caddr p14) (- (nth 1 shp_data) flgthk)))
            p24 (list (car p13) (cadr p13) (- (caddr p13) (- (nth 1 shp_data) flgthk)))
            p7  (list (car p1)   (cadr p1)  (- (caddr p1)  (nth 1 shp_data)))
            p8  (list (car p2)   (cadr p2)  (- (caddr p2)  (nth 1 shp_data)))
            p19 (list (car p13)  (cadr p13) (- (caddr p13) (nth 1 shp_data)))
            p20 (list (car p14)  (cadr p14) (- (caddr p14) (nth 1 shp_data)))
      )
      (setq shp_list
         (list p1  p2  p3  p4  p5  p6  p7  p8  p9  p10 p11 p12
               p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 ""
                1   2  14 13 ""
                2   3  15 14 ""
                3   4  16 15 ""
                4  10  22 16 ""
               10   9  21 22 ""
                9   8  20 21 ""
                8   7  19 20 ""
                7  12  24 19 ""
               12  11  23 24 ""
               11   5  17 23 ""
                5  17  18  6 ""
                6  18  13  1 ""

                 1  -6  3 2 ""
                 5 -11 10 -4 ""
                 8 -9 12 7 ""

                 13 -18 15 14 ""
                 22 -16 17 -23 ""
                 20 -21 24 19 "" ""
         )
      )
      (stl_set_lyr "stl-objt")
      (setq a (getvar "blipmode") c (getvar "osmode"))
      (setvar "blipmode" 0)
      (setvar "osmode" 0)
      (command ".pface")
      (mapcar 'command shp_list)
      (mapcar 'setvar '("blipmode" "osmode") (list a c))
      (setq ip1 ip2)
      (setvar "lastpoint" ip2)
   )
   (princ)
)
'()
)
