;Draw W/WT Shapes Top and Bottom Views
(apply '(lambda ( / lp p1 p2 ang a b c d e f g h i j k l m n r)
   (setq m (getvar "blipmode"))
   (setvar "blipmode" 1)
   (if (= STL_VIEW_MODE "stl_vc")
      (princ (strcat "\nDrawing Top View of [" (nth 0 SHP_DATA) "]"))
      (princ (strcat "\nDrawing Bottom Section of [" (nth 0 SHP_DATA) "]"))
   )
   (if (not (setq lp (getpoint "\n[PICK] Start point: ")))
      (setq lp (getvar "lastpoint"))
   )
   (while (setq p1 lp p2 (getpoint lp "\n[PICK] End point: "))
      (setq lp p2)
      (setq ang (angle p1 p2))
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq i (+ ang (* pi 1.5))
                  g (polar p1 i (/ (nth 3 SHP_DATA) 2))
                  h (polar p2 i (/ (nth 3 SHP_DATA) 2))
                  g (polar g (+ ang pi) 6.0)
                  h (polar h ang 6.0)
            )
         )
         ((= STL_INPUT_MODE "stl_ib")
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq i (+ ang (* pi 0.5))
                  g (polar p1 i (/ (nth 3 SHP_DATA) 2))
                  h (polar p2 i (/ (nth 3 SHP_DATA) 2))
                  g (polar g (+ ang pi) 6.0)
                  h (polar h ang 6.0)
            )
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq i (+ ang (* pi 0.5))
                  g (polar p1 (+ ang pi) 6.0)
                  h (polar p2 ang 6.0)
                  p1 (polar p1 (+ i pi) (/ (nth 3 SHP_DATA) 2))
                  p2 (polar p2 (+ i pi) (/ (nth 3 SHP_DATA) 2))
            )
         )
      )
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (stl_set_lyr "stl-cntr")
      (stl_draw_line (list g h) nil)
      (setq n (entlast))
      (setq c (polar p1 i (nth 3 SHP_DATA)))
      (setq d (polar p2 i (nth 3 SHP_DATA)))
      (stl_set_lyr "stl-objt")
      (stl_draw_line (list p1 p2 d c) t)
      (setq j (if (= STL_DRAW_MODE "stl_db") 0.25 (/ (nth 2 SHP_DATA) 2)))
      (setq j (- (/ (nth 3 SHP_DATA) 2) j))
      (setq e (polar p1 i j))
      (setq f (polar p2 i j))
      (setq g (polar c (+ i pi) j))
      (setq h (polar d (+ i pi) j))
      (cond
         ((= STL_VIEW_MODE "stl_vc") (stl_set_lyr "stl-hidn"))
         ((= STL_HATCH_MODE "stl_hb"))
         (t
            (command ".pline" e "w" 0.0 "" f h g "c")
            (setq a (entlast))
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos ang) a "")
            (setvar "highlight" 0)
            (command ".erase" a "")
            (setvar "highlight" 1)
            (stl_set_lyr "stl-objt")
         )
      )
      (stl_draw_line (list e f) nil)
      (stl_draw_line (list g h) nil)
      (setvar "blipmode" 1)
      (setvar "osmode" r)
      (setvar "blipmode" m)
      (command ".undo" "e")
      (if (= STL_VIEW_MODE "stl_vc")
         (princ (strcat "\nDrawing Top View of [" (nth 0 SHP_DATA) "]"))
         (princ (strcat "\nDrawing Bottom Section of [" (nth 0 SHP_DATA) "]"))
      )
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" m)
)
'()
)