;Draw 3d S Shape
(apply '(lambda (/ a b c webthk halfflg halfweb halfdep webdpth a90 a270 ip1 ip2
                   cp1 cp2 cp3 cp4 p1  p2  p3  p4  p5  p6  p7  p8  p9  p10
                   p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24)

   (setvar "cmdecho" 0)
   (princ (strcat "\nDrawing 3d View of [" (nth 0 SHP_DATA) "]"))
   (setq ip1
      (cond
         ((= STL_INPUT_MODE "stl_ia") (setq b 1) (getpoint "\n[PICK] Center Top of Flange point: "))
         ((= STL_INPUT_MODE "stl_ib") (setq b 2) (getpoint "\n[PICK] Center Bottom of Flange point: "))
         ((= STL_INPUT_MODE "stl_ic") (setq b 3) (getpoint "\n[PICK] Center of Web at X Axis: "))
      )
   )
   (setq webthk (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))   ;Draw Mode
   (while (setq ip2 (getpoint ip1 "\n[PICK] End point: "))
      (setq halfflg (/ (nth 3 shp_data) 2.0)
            halfweb (/ webthk 2.0)
            halfdep (/ (nth 1 shp_data) 2.0)
            webdpth (- (nth 1 shp_data) (* 2.0 (nth 5 shp_data)))
      )
      (setq a90  (+ (angle ip1 ip2) (* pi 0.5))
            a270 (+ (angle ip1 ip2) (* pi 1.5))
      )
      (cond
         ((= b 1) (setq cp1 ip1 cp2 ip2))
         ((= b 2)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 1 SHP_DATA)))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 1 SHP_DATA)))
            )
         )
         ((= b 3)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) halfdep))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) halfdep))
            )
         )
      )
      (setq p1  (polar cp1 a90 halfflg)
            p5  (polar cp1 a90 halfweb)
            p13 (polar cp2 a90 halfflg)
            p17 (polar cp2 a90 halfweb)
            p2  (polar cp1 a270 halfflg)
            p4  (polar cp1 a270 halfweb)
            p14 (polar cp2 a270 halfflg)
            p16 (polar cp2 a270 halfweb)
            p6  (list (car p1)  (cadr p1)  (- (caddr p1)  (nth 6 shp_data)))
            p18 (list (car p13) (cadr p13) (- (caddr p13) (nth 6 shp_data)))
            p3  (list (car p2)  (cadr p2)  (- (caddr p2)  (nth 6 shp_data)))
            p15 (list (car p14) (cadr p14) (- (caddr p14) (nth 6 shp_data)))
            p5  (list (car p5)  (cadr p5)  (- (caddr p5)  (nth 5 shp_data)))
            p17 (list (car p17) (cadr p17) (- (caddr p17) (nth 5 shp_data)))
            p4  (list (car p4)  (cadr p4)  (- (caddr p4)  (nth 5 shp_data)))
            p16 (list (car p16) (cadr p16) (- (caddr p16) (nth 5 shp_data)))
            p7  (list (car p1)   (cadr p1)  (- (caddr p1)  (nth 1 shp_data)))
            p8  (list (car p2)   (cadr p2)  (- (caddr p2)  (nth 1 shp_data)))
            p19 (list (car p13)  (cadr p13) (- (caddr p13) (nth 1 shp_data)))
            p20 (list (car p14)  (cadr p14) (- (caddr p14) (nth 1 shp_data)))
            p10 (list (car p4)  (cadr p4)  (- (caddr p4)  webdpth))
            p11 (list (car p5)  (cadr p5)  (- (caddr p5)  webdpth))
            p22 (list (car p16) (cadr p16) (- (caddr p16) webdpth))
            p23 (list (car p17) (cadr p17) (- (caddr p17) webdpth))
            p12 (list (car p7)  (cadr p7)  (+ (caddr p7)  (nth 6 shp_data)))
            p9  (list (car p8)  (cadr p8)  (+ (caddr p8)  (nth 6 shp_data)))
            p21 (list (car p20) (cadr p20) (+ (caddr p20) (nth 6 shp_data)))
            p24 (list (car p19) (cadr p19) (+ (caddr p19) (nth 6 shp_data)))
            cp3 (list (car cp1) (cadr cp1) (- (caddr cp1) (nth 1 shp_data)))
            cp4 (list (car cp2) (cadr cp2) (- (caddr cp2) (nth 1 shp_data)))
      )
      (setq shp_list
         (list p1  p2  p3  p4  p5  p6  p7  p8  p9  p10 p11 p12
               p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 cp1 cp2 cp3 cp4 ""
                1   2  14 13 ""
                2   3  15 14 ""
                3   4  16 15 ""
                4  16  22 10 ""
               10   9  21 22 ""
                9   8  20 21 ""
                8   7  19 20 ""
                7  12  24 19 ""
               12  11  23 24 ""
               11  23  17  5 ""
                5   6  18 17 ""
                6   1  13 18 ""

                1   6  -5  25 ""
                4   3   2 -25 ""
                -25 -5 -4 ""
               11  12   7 -27 ""
                8   9 -10  27 ""
                -27 -10 -11 ""
                5 -11 10 -4 ""

               14  15 -16  26 ""
               17  18  13 -26 ""
                -26 -17 -16 ""
               22 21 20 -28 ""
               19 24 -23 28 ""
                -28 -22 -23 ""
               17 -23 22 -16 "" ""
         )
      )
      (stl_set_lyr "stl-objt")
      (setq a (getvar "blipmode") c (getvar "osmode"))
      (setvar "blipmode" 0)
      (setvar "osmode" 0)
      (command ".pface")
      (mapcar 'command shp_list)
      (mapcar 'setvar '("blipmode" "osmode") (list a c))
      (setq ip1 ip2)
      (setvar "lastpoint" ip2)
   )
   (princ)
)
'()
)
